"""The main code with all the modules loading and running them. Will have to adapt to the new code 927
The final step would be to add the sampling algorithm here...."""


from data_loader import list_data, list_directories, list_files, loadx_variable
from preprocessor import preprocess_data
from arima_model import plot_time_series
from lstm_model import create_dataset, plot_training_history, plot_forecast
from utils import load_config
from utils_plot import Plotter

def main():

    # Loads the configuration file with all settings
    config = load_config('config.yaml')

    # Lists the main directory of the data
    path = config['data_path']
    version = config['version']
    data = list_data(path)
    files = list_files(path)
    dir = list_directories(path)
    check_variable = config['variables']
    variable_load = loadx_variable(path,dir,check_variable,version)
    #print("variable_load.keys()",variable_load.keys())
    #print("variable_load.items()",variable_load.items())

    # Extract relevant variables from the dataset
    intpp_data = variable_load['INTPP']
    latitudes = intpp_data['latitude']
    longitudes = intpp_data['longitude']

    print("latitudes",latitudes)
    print("latitudes[0]",latitudes[0])
    # Define the time index you want to plot (e.g., 100th time step)
    time_index = 100

    # List of index pairs where markers should be placed
    index_pairs = config['index_pairs']


    # Initialize the Plotter class
    plotter = Plotter(intpp_data['intpp'], latitudes, longitudes, variable_load)

    # Plot with markers
    #plotter.plot_with_markers('test',time_index, index_pairs)


    # Plot the series as subplots for different species and locations
    plotter.plot_series(index_pairs)

    #scaled_data, scaler = preprocess_data(data)

    # ARIMA Model
    #arima_model = train_arima_model(scaled_data, **config['arima_params'])
    #plot_arima_results(scaled_data, arima_model, 10, config['output_path'])

    # LSTM Model
    #lstm_model = create_lstm_model((scaled_data.shape[1], 1), config['lstm_params']['neurons'])
    #lstm_model = train_lstm_model(lstm_model, scaled_data, scaled_data, config['lstm_params']['epochs'], config['lstm_params']['batch_size'])
    #plot_lstm_results(scaled_data, lstm_model, scaler, 10, config['output_path'])

if __name__ == "__main__":
    main()
